// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.cdm.remote.json.processor.bean;

import java.util.Arrays;
import java.util.List;

import net.sf.json.JSONObject;
import net.sf.json.JsonConfig;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.taxon.TaxonNode;

/**
 * @author n.hoffmann
 * @created Apr 9, 2010
 * @version 1.0
 */
public class TaxonNodeBeanProcessor extends AbstractCdmBeanProcessor<TaxonNode> {
	
	private static final Logger logger = Logger.getLogger(TaxonNodeBeanProcessor.class);

	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.remote.json.processor.AbstractCdmBeanProcessor#getIgnorePropNames()
	 */
	@Override
	public List getIgnorePropNames() {
		return Arrays.asList(new String[]{
				"parent", //TODO put in json-config ignore list ?
		});
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.cdm.remote.json.processor.AbstractCdmBeanProcessor#processBeanSecondStep(eu.etaxonomy.cdm.model.common.CdmBase, net.sf.json.JSONObject, net.sf.json.JsonConfig)
	 */
	@Override
	public JSONObject processBeanSecondStep(TaxonNode bean, JSONObject json,
			JsonConfig jsonConfig) {
		return json;
	}
}
